typedef struct game_object_t
{
   int x;
   int y;
   unsigned int graphic;
   unsigned char type;
   unsigned char state;
   fixed angle;

   struct game_object_t *next;
} game_object_t;

typedef struct
{
   game_object_t obj;
   int teleports;
   int airstrikes;
   long score;
} player_t;

typedef struct
{
   game_object_t obj;
   int dest_x;
   int dest_y;
} plane_t;

  
extern player_t *player;
extern plane_t *plane;

extern game_object_t *objlist_head;

// type
#define TYPE_PLAYER     0
#define TYPE_ROBOT      1
#define TYPE_JUNK       2
#define TYPE_PLANE      3

// states
#define PLAYER_LIVING   0
#define PLAYER_DYING    1
#define PLAYER_DEAD     2
#define PLAYER_TELEPORT 3
#define ROBOT_LIVING    4
#define ROBOT_DYING     5
#define JUNK            6
#define AIRSTRIKE       7
#define PLANE_ENTERING  8
#define PLANE_LEAVING   9

#define POS_RAND -1

#define FIELD_W 640
#define FIELD_H 480
#define FIELD_X 0
#define FIELD_Y 0

// function prototypes
void add_object (game_object_t *obj);
void draw_object (game_object_t *obj);
int check_done (void);
void move_obj (game_object_t *obj, int vel);
void create_plane (void);
void set_starting_pos (game_object_t *obj);
void do_ui (game_object_t *obj);
int checkcollision (game_object_t *obj1, game_object_t *obj2);
void do_robot (game_object_t *robot);
void do_plane(plane_t *plane);
void do_junk(game_object_t *obj);
void do_game (void);
void get_random_xy(int *x, int *y);
fixed calculate_angle (int x, int y, int dest_x, int dest_y);
void intro(void);
void create_buffer(void);
void create_player (void);
void destroy_plane (void);
void create_robot (void);
void create_junk (int x, int y);
void create_objects(int robots, int junk);
void destroy_objects (void);
void draw_buffer(void);
void gameloop (void);
int main (int argc, char *argv[]);
